package de.unisaar.jfap.ex7.visitors;

import de.unisaar.jfap.ex7.DirectedGraph;
import de.unisaar.jfap.ex7.Edge;

/**
 * Extend the {@link GraphVisitor} interface with methods required only in breadth first search.
 *
 * @author Jörg Steffen, DFKI
 * @param <E> the type of information assigned to the edges of the traversed graph
 * @param <V> the type of information assigned to the vertices of the traversed graph
 */
public interface BfsGraphVisitor<E, V> extends GraphVisitor<E, V> {

  /**
   * Call when a tree edge is used.
   *
   * @param e the tree edge
   * @param g the graph to which the tree edge belongs to
   */
  void treeEdge(Edge<E> e, DirectedGraph<E, V> g);
}
